<?php
//------Dir Definition------
$site_title="SPD/USTC";
$site_fulltitle="Space Physics Division of USTC";

$libdir="$rootdir/phplib";
$etcdir="$rootdir/etc";
$imgdir="$webrootdir/images";
$userhomedir="$rootdir/users";
$userwebdir="$webrootdir/users";
$deleteddir="$rootdir/deleted";
$counterdir="$rootdir/counter";
//------Dir Definition------

//------Preproccess------
include("$libdir/rand_ns.php");
include("$libdir/datetime_func.php");
include("$libdir/sendemail.php");
include("$libdir/reload_url_options.php");
include("$libdir/authlib.php");
include("$libdir/counter.php");

$pos=strrpos($_SERVER['SCRIPT_NAME'],'/');
if($pos<2) $cursubpath="";
else $cursubpath=substr($_SERVER['SCRIPT_NAME'],strlen($webdir),$pos-strlen($webdir));
$pos=strrpos($cursubpath,'/');
if($pos!==false) $cursubpath=substr($cursubpath,$pos+1);  

import_request_variables("GP","gp_");
$default_language=0;
$default_ctidx=1;
//------Set Cookies------
if(isset($_COOKIE['language'])) $default_language=$_COOKIE['language'];
if(!isset($gp_language) || $gp_language>1 || $gp_language<0) $language=$default_language; else $language=$gp_language;
if(!isset($_COOKIE['language']) || $_COOKIE['language']!="$language") 
{
	setcookie('language',"$language",time()-3600);
	setcookie('language',"$language",time()+86400*30,"/");
}
if(isset($_COOKIE['ctidx'])) $default_ctidx=$_COOKIE['ctidx'];
if(!isset($gp_colortableidx) || $gp_colortableidx>1 || $gp_colortableidx<0 || $gp_colortableidx=="") $colortableidx=$default_ctidx; else $colortableidx=$gp_colortableidx;
if(!isset($_COOKIE['ctidx']) || $_COOKIE['ctidx']!="$colortableidx") 
{
	setcookie('ctidx',"$colortableidx",time()-3600);
	setcookie('ctidx',"$colortableidx",time()+86400*30,"/");
}
//------Set Cookies------
//------Preproccess------

//------send email------
$semail="$libdir/semail";
$mailserver="202.38.64.8";
$mailusername="eW13YW5n";
$mailpassword="eGJqLnFiei5zZCBxemM=";
$mailsender="SPACE <webmaster@space.ustc.edu.cn>";
$mailtype=1; #0:plain, 1:html
$mailsignature="<br><br>--<br>Designed & developed by Yuming Wang, Copyright &copy; 2006, All rights reserved.";
$mailusermanagers="ymwang@ustc.edu.cn";
//------send email------

//------DO NOT change------
$account_item_total_num=17;
//------DO NOT change------
//------Constant Array------
$monthlength=array(31,28,31,30,31,30,31,31,30,31,30,31);
$displaycode=array("none","");
//------Constant Array------
//------Variables------
$password_minlen=6;
$errinfo="";
$newmentiontime=3; //days
$newoptions=array();
$upload_rate_assumption=5.; //KB/s
$upload_file_size_max=10; //MB
$upload_timeout=$upload_file_size_max*1024./$upload_rate_assumption; //default 10 MB
$pagewidth=960;
$bannerwidth=320;
$forbidden_ftype=array("php");
//------Variables------
//------authorization------
//$logoutpage="$webrootdir/index.php";
//if($_SESSION['independentoptions']['optionsnoentrance']!=null) $logoutpage=$logoutpage."?".$_SESSION['independentoptions']['optionsnoentrance'];
$authpage="$libdir/auth.php";
$pwdfile="$etcdir/password.php";
$pwdfpar="$etcdir/pwdfpar.php";
$allowuserlistfilename="allowuserlist.php";
$allowgrouplistfilename="allowgrouplist.php";
//$anonymousgroup=401;
//$permission_mode=1;  //see permission fuction in authlib.php
//$user_permission_mode=1;
$inline=1;
//------authorization------
//------information------
$homepage="$webrootdir/index.html";
$lastupdatefunc="$libdir/lastupdate.php";
$denypage="$libdir/deny_info.php";
$faqpage="$webrootdir/help/index.php";
//------information------
//------account manage------
$get_account_parfunc="$libdir/get_account_parameters.php";
include("$get_account_parfunc");
$account_description_length=300;
$homedirtree=array("calendar","resume","publication","project","address");
//------account manage------
//------Forum------
//name can not be the name of any existing directory in $forumdir!!!
$forumdir="cforums";
$forum_sections=array(array("id"=>"91","personal"=>0,"name"=>"notice","label"=>array("Notice","ͨ"),"type"=>"public","manager"=>array("ymwang@ustc.edu.cn")),
		array("id"=>"93","personal"=>0,"name"=>"course","label"=>array("Course","γ"),"type"=>"public","manager"=>array("qmlu@ustc.edu.cn","ymwang@ustc.edu.cn")),
		array("id"=>"95","personal"=>0,"name"=>"privatecommunication","label"=>array("Private","ڲ"),"type"=>"public","manager"=>array("ymwang@ustc.edu.cn")),
		array("id"=>"81","personal"=>1,"name"=>"blog","label"=>array("Blog",""),"type"=>"individual","manager"=>array())
		);
//------Forum------
//------menu------
$toppage_label=array("Homepage","ҳ");
//permission: the lowest permission request;
//permission_mode: see explanation in permission() in authlib.php, the first letter is for whole site, and the latter is for individual
$menu_list_all=array(
								 array("id"=>"09","personal"=>0,"label"=>array("FAQ","FAQ"),"link"=>"help/index.php","path"=>"$rootdir/help","hidden"=>1,"permission"=>0,"permission_mode"=>"11"),
								 array("id"=>"01","personal"=>0,"label"=>array("Accounts","ʻ"),"link"=>"account_manager/index.php","path"=>"$rootdir/account_manager","hidden"=>0,"permission"=>2,"permission_mode"=>"01"),
								 array("id"=>"02","personal"=>0,"label"=>array("Introduction",""),"link"=>"intro/index.php","path"=>"$rootdir/intro","hidden"=>0,"permission"=>1,"permission_mode"=>"11"),
								 array("id"=>"03","personal"=>0,"label"=>array("Member","Ա"),"link"=>"member/index.php","path"=>"$rootdir/member","hidden"=>0,"permission"=>1,"permission_mode"=>"11"),
								 array("id"=>"10","personal"=>0,"label"=>array("Account","ʻ"),"link"=>"signup/index.php","path"=>"$rootdir/signup","hidden"=>1,"permission"=>1,"permission_mode"=>"11"),
								 array("id"=>"13","personal"=>1,"label"=>array("CV","˼"),"link"=>"resume/index.php","path"=>"$rootdir/resume","hidden"=>0,"permission"=>1,"permission_mode"=>"11"),
								 array("id"=>"14","personal"=>2,"label"=>array("Calendar",""),"link"=>"calendar/index.php","path"=>"$rootdir/calendar","hidden"=>0,"permission"=>1,"permission_mode"=>"11"),
								 array("id"=>"15","personal"=>1,"label"=>array("Address","ͨѶ¼"),"link"=>"address/index.php","path"=>"$rootdir/address","hidden"=>0,"permission"=>1,"permission_mode"=>"10"),
								 array("id"=>"21","personal"=>1,"label"=>array("Publication",""),"link"=>"publication/index.php","path"=>"$rootdir/publication","hidden"=>0,"permission"=>1,"permission_mode"=>"11"),
								 array("id"=>"22","personal"=>1,"label"=>array("Project","Ŀ"),"link"=>"project/index.php","path"=>"$rootdir/project","hidden"=>0,"permission"=>1,"permission_mode"=>"11"),
								 array("id"=>"25","personal"=>0,"label"=>array("DRY",""),"link"=>"dry/index.php","path"=>"$rootdir/dry","hidden"=>0,"permission"=>2,"permission_mode"=>"11"),
								 );
$allowed_functions_default=array("02","03","09","10","14","91","93");
$allowed_user_functions_default=array("user_manager"=>array("01","13","15","81","95"),
		"facult_staff"=>array("13","15","21","22","25","81","95"),
		"student"=>array("13","15","21","22","25","81","95"),
		"alumni"=>array("13","15","21","81"),
		"visitor"=>array("13","15","21","22"),
		"guest"=>array("13","15","81"),
		);
for($i=0;$i<count($forum_sections);$i++)
{
	array_push($menu_list_all,array("id"=>$forum_sections[$i]['id'],"personal"=>$forum_sections[$i]['personal'],"label"=>$forum_sections[$i]['label'], "link"=>"forum/index.php","option"=>("section=".$forum_sections[$i]['name']), "path"=>"$rootdir/forum","hidden"=>0,"permission"=>1,"permission_mode"=>"11"));
}
$curlocationid=-1;
$updated_menu_id=array("public"=>array("09","02","03","91","93","95"),
											"personal"=>array("13","14","21","22","81"));
//------menu------
//------symbols------
$separator=":";
$datacover_symbol=array("<?php /*","*/ ?>");
//------symbols------
//------labels------
$display_label=array(array("Open ",""),array("Hide ",""));
$panel_label=array("Update Panel","");
$anonymous_label=array("Anonymous","");
$faq_label=array("FAQ","FAQ");
$location_label=array("Location","ǰλ");
$signup_label=array("Sign Up","ע");
$updateaccount_label=array("Update Account Info","ʻϢ");
$update_label=array("Update","");
$yesno_label=array(0=>array("No",""),1=>array("Yes",""));
$reset_label=array("Reset","");
$languagever_label=array("İ","English Version");
$language_label=array("en"=>array("English","Ӣ"),"ch"=>array("Chinese",""));
$submit_label=array("Submit","ύ");
$back_label=array("Back","");
$sex_label=array(array("Female","Ů"), array("Male",""));
$weekday_label=array(array("Sunday",""),array("Monday","һ"),array("Tuesday","ڶ"),array("Wednesday",""),
               array("Thursday",""),array("Friday",""),array("Saturday",""));
$weekdayshort_label=array(array("SUN",""),array("MON","һ"),array("TUE",""),array("WED",""),
               array("THU",""),array("FRI",""),array("SAT",""));
//$week_label=array(array("Sun","Mon","Tue","Wed","Thu","Fri","Sat"),array("","һ","","","","",""));
$month_label=array(array("January","һ"),array("February",""),array("March",""),array("April",""),array("May",""),array("June",""),array("July",""),array("August",""),array("September",""),array("October","ʮ"),array("November","ʮһ"),array("December","ʮ"));
//------labels------
//------icons------
$bannerimg="$imgdir/banner/step1.gif";
$addicon="$imgdir/additem.gif";
$delicon="$imgdir/del.gif";
$modicon="$imgdir/mod.gif";
$atticon="$imgdir/attachment.gif";
$picicon="$imgdir/picture.gif";
$hiddenicon="$imgdir/hidden.gif";
$regularicon="$imgdir/regular.gif";
$importanticon="$imgdir/important.gif";
$collectionicon="$imgdir/collection.gif";
$creamicon="$imgdir/cream.gif";
$topicon="$imgdir/top.gif";
$newicon="$imgdir/new.gif";
//------icons------
//------properties------
$colortables=array(array("White/Black","ڵװ",array("white","black")),array("Black/White","׵׺",array("black","white")));
$linkcolortables=array(array("#ffddff","#dddddd","purple","red"),array("#552255","#555555","purple","red"));
$linkcolortable=$linkcolortables[$colortableidx];
$crossbgcolors=array("#330033","#ccffcc");
$crossbgcolor=$crossbgcolors[$colortableidx];
$bordershadowcolors=array("#333333","#aaaaaa");
$bordershadowcolor=$bordershadowcolors[$colortableidx];
$highlightcolors=array("#994400","yellow");
$highlightcolor=$highlightcolors[$colortableidx];
//------properties------
//------Make Header------
include("$libdir/header.php");
mkhead("Yuming Wang", "gb2312", "Welcome to ".$site_fulltitle, "Times New Roman, Arial", "11pt", $linkcolortable,"1100", $colortables[$colortableidx][2]);
include("$libdir/htmlinsert.php");
//------Make Header------
?>
