<?php
function getprivilege($userid,$groupid,$preright,$privilege,$status,$specialuser,$specialgroup,$manager,$scprivilege)
{
//status: 0: normal; 1: locked/read only; 2: hidden;
//content: 0: no r/re/w; 1: r only; 2: r/re; 3: r/re/w; 4: manager
//attachment: 0: invisible; 1: visible
	if($userid=="0" || ($manager[0]!=null && array_search($userid,$manager)!==false)) return "41";
	if(strlen($scprivilege)==2 && $status!=1)	return $scprivilege; //special privilege overwrite others.
	if($preright=="41") return "41";
	if($preright<0) $preright="31";
	if($userid=="")	
	{
		$right=$privilege[2];
		$attright=$privilege[3];
		if($status==1) 	return min($preright[0],$right,1).min($preright[1],$attright);
		else return min($preright[0],$right).min($preright[1],$attright);
	}
	$preattright=min($preright[1],$privilege[1]);
	//if($status>1)	return "00";
	if($status==1)	return "1".$preattright;
	$preright=min($preright,$privilege[0]);

	if($specialuser!=null)
	{
		if(array_search("00".$userid,$specialuser)!==false) return "00";
		if(array_search("10".$userid,$specialuser)!==false) return "10";
		if(array_search("20".$userid,$specialuser)!==false) return "20";
		if(array_search("30".$userid,$specialuser)!==false) return "31";
		if(array_search("01".$userid,$specialuser)!==false) return "00";
		if(array_search("11".$userid,$specialuser)!==false) return "11";
		if(array_search("21".$userid,$specialuser)!==false) return "21";
		if(array_search("31".$userid,$specialuser)!==false) return "31";
	}

	if($groupid=="" || $specialgroup==null) return $preright.$preattright;
	
	$right=$preright;
	$attright=$preattright;
	for($i=0;$i<count($groupid);$i++)
	{
		//if($right>$preright || $attright>$preattright) 
		//{
			if($right>$preright) $preright=$right;
			if($attright>$preattright) $preattright=$attright;
		//}
		if(array_search("00".$groupid[$i],$specialgroup)!==false) {$right=0; $attright=0; continue;}
		if(array_search("10".$groupid[$i],$specialgroup)!==false) {$right=1; $attright=0; continue;}
		if(array_search("20".$groupid[$i],$specialgroup)!==false) {$right=2; $attright=0; continue;}
		if(array_search("30".$groupid[$i],$specialgroup)!==false) {$right=3; $attright=1; continue;}
		if(array_search("01".$groupid[$i],$specialgroup)!==false) {$right=0; $attright=0; continue;}
		if(array_search("11".$groupid[$i],$specialgroup)!==false) {$right=1; $attright=1; continue;}
		if(array_search("21".$groupid[$i],$specialgroup)!==false) {$right=2; $attright=1; continue;}
		if(array_search("31".$groupid[$i],$specialgroup)!==false) {$right=3; $attright=1; continue;}
	}
	if($right>$preright) $preright=$right;
	if($attright>$preattright) $preattright=$attright;
	return $preright.$preattright;
}

function loadsectioninfo($sectioninfofile,&$sectioninfo,&$boardsinfo)
{
	global $datacover_symbol,$separator;
	$unit=5;
	$headline=4;

	if(!file_exists($sectioninfofile))
	{
		$directory=substr($sectioninfofile,0,strrpos($sectioninfofile,'/'));
		if(!is_dir($directory) && !is_file($directory))
		{
			mkdir($directory);
			touch("$directory/index.htm");
		}
		if(!is_dir($directory)) return false;
        	$h=fopen($sectioninfofile,'w');
        	if($h)
        	{
           	fwrite($h,$datacover_symbol[0]."\n");
						fwrite($h,"0".$separator."2".$separator."3111".$separator."0".$separator.$separator."\n");
						fwrite($h,"\n");
						fwrite($h,"\n");
						fwrite($h,"\n");
            fwrite($h,$datacover_symbol[1]."\n");
            fclose($h);
        	}
        	else
        	{
            return false;
        	}
	}

	$sectioninfo=array();
	$lines=file($sectioninfofile);
	$lnum=(count($lines)-$headline-2)/$unit;

	if(count($lines)<($headline+2)) return true;

	$str=explode($separator,$lines[1]);
	$specialcode=explode($separator,rawurldecode(trim($str[4])));
	$sectioninfo=array("showtype"=>$str[0],"column"=>$str[1],"privilege"=>$str[2],"status"=>$str[3]);
	$specialgroup=explode($separator,$lines[2]);
	for($i=0;$i<count($specialgroup)-1;$i++)	$specialgroup[$i]=strtolower(trim($specialgroup[$i]));
	array_pop($specialgroup);
	$specialuser=explode($separator,$lines[3]);
	for($i=0;$i<count($specialuser)-1;$i++)	$specialuser[$i]=strtolower(trim($specialuser[$i]));
	array_pop($specialuser);
	$category=explode($separator,$lines[4]);
	for($i=0;$i<count($category)-1;$i++)	$category[$i]=trim($category[$i]);
	array_pop($category);
	$sectioninfo=array_merge($sectioninfo,array("specialcode"=>$specialcode),array("specialgroup"=>$specialgroup),array("specialuser"=>$specialuser),array("category"=>$category));

	$boardsinfo=array();
	$idarr=array();
	$lastmodarr=array();
	$labelarr=array();
	$categoryarr=array();
	$showmodearr=array();
	$liststylearr=array();
	$maxrecordsarr=array();
	$managerarr=array();
	$indexarr=array();
	$privilegearr=array();
	$specialgrouparr=array();
	$specialuserarr=array();
	$specialcodearr=array();
	$statusarr=array(); //lock, close, ...
	$descriptionarr=array();
	for($i=0;$i<$lnum;$i++)
	{
		$l=$i*$unit+$headline+1;
		$str=explode($separator,$lines[$l]);
		$id=$str[0];
		$lastmod=$str[1];
		$status=$str[2];
		$privilege=$str[3];
		$category=$str[4];
		if($str[5]=="") $str[5]=$str[6];
		elseif($str[6]=="") $str[6]=$str[5];
		$label=array($str[5],$str[6]);
		$index=$str[7];
		$showmode=$str[8];
		$maxrecords=$str[9];
		$liststyle=$str[10];
		$specialcode=explode($separator,rawurldecode(trim($str[11])));
		$manager=explode($separator,$lines[$l+1]);
		for($j=0;$j<count($manager)-1;$j++)	$manager[$j]=strtolower(trim($manager[$j]));
		array_pop($manager);
		$specialgroup=explode($separator,$lines[$l+2]);
		for($j=0;$j<count($specialgroup)-1;$j++)	$specialgroup[$j]=strtolower(trim($specialgroup[$j]));
		array_pop($specialgroup);
		$specialuser=explode($separator,$lines[$l+3]);
		for($j=0;$j<count($specialuser)-1;$j++)	$specialuser[$j]=strtolower(trim($specialuser[$j]));
		array_pop($specialuser);
		$description=explode($separator,$lines[$l+4]);
		$description=$description[0];

		array_push($idarr,$id);
		array_push($lastmodarr,$lastmod);
		array_push($statusarr,$status);
		array_push($privilegearr,$privilege);
		array_push($categoryarr,$category);
		array_push($labelarr,$label);
		array_push($indexarr,$index);
		array_push($showmodearr,$showmode);
		array_push($maxrecordsarr,$maxrecords);
		array_push($liststylearr,$liststyle);
		array_push($managerarr,$manager);
		array_push($specialgrouparr,$specialgroup);
		array_push($specialuserarr,$specialuser);
		array_push($specialcodearr,$specialcode);
		array_push($descriptionarr,$description);
	}
	$boardsinfo=array("id"=>$idarr,"lastmod"=>$lastmodarr,"status"=>$statusarr,"privilege"=>$privilegearr,"category"=>$categoryarr,"label"=>$labelarr,"index"=>$indexarr,"manager"=>$managerarr,"specialcode"=>$specialcodearr,"specialgroup"=>$specialgrouparr,"specialuser"=>$specialuserarr,"description"=>$descriptionarr,"showmode"=>$showmodearr,"liststyle"=>$liststylearr,"maxrecords"=>$maxrecordsarr);
	$sectioninfo=array_merge($sectioninfo,array("boardnum"=>$lnum));

	return true;
}

function writesectioninfofile($sectioninfofile,$setup,$board,$mode,&$errinfo)
//mode: 0-section; 1-board add; 2-board mod; 3-board del
{
	global $datacover_symbol,$separator;
        $unit=5;
	$headline=4;

	$lines=file($sectioninfofile);
	$lnum=(count($lines)-$headline-2)/$unit;
	if($mode>0)
	{
		$label_en=rawurlencode(trim($board['label'][0]));
		$label_ch=rawurlencode(trim($board['label'][1]));
		$idline=-1;
		for($i=0;$i<$lnum;$i++)
		{
			$l=$i*$unit+$headline+1;
	                $str=explode($separator,$lines[$l]);
			if($board['id']==$str[0])	$idline=$l;
			elseif(($str[5]!="" && $label_en==$str[5]) || ($str[6]!="" && $label_ch==$str[6]))
			{
				$errinfo="Duplicate Title";
				return false;
			}
		}
		if($mode==1)
		{
			$newdir=$board['path']."/".$board['id'];
			if(mkdir($newdir)===false)
			{
				$errinfo="Fail to create a new directory.";
				return false;
			}
			touch("$newdir/index.htm");
		}
		elseif($mode==3)
		{
			$olddir=$board['path']."/".$board['id'];
			$delpool=$board['path']."/deleted";
			$newdir=$delpool."/".$board['id'].".del";
			$ready=true;
			if(!is_dir($delpool) && !is_file($delpool))
			{
				$ready=mkdir($delpool);
				touch("$delpool/index.htm");
			}
			elseif(!is_dir($delpool))	$ready=false;
			if($ready==false)
			{
				$errinfo="Fail to create pool for deletion.";
				return false;
			}
			else
			{
				if(rename($olddir,$newdir)==false)
				{
					$errinfo="Fail to delete.";
					return false;
				}
			}
		}
	}

	$h=fopen($sectioninfofile,'w');
	if(!$h) 
	{
		if($mode==1) rmdir($newdir);
		$errinfo="Can't Open Data File";
		return false;
	}
	
	switch($mode)
	{
	  case 0: //setup
		fwrite($h,$datacover_symbol[0]."\n");
		fwrite($h,$setup[0]."\n");
		fwrite($h,$setup[1]."\n");
		fwrite($h,$setup[2]."\n");
		fwrite($h,$setup[3]."\n");
		if(count($lines)>($headline+2))
		{
			for($i=$headline+1;$i<count($lines)-1;$i++) fwrite($h,$lines[$i]);
		}
		fwrite($h,$datacover_symbol[1]."\n");
		break;
	  case 1: //add
		for($i=0;$i<count($lines)-1;$i++) fwrite($h,$lines[$i]);
		$str=$board['id'].$separator.$board['lastmod'].$separator.$board['status'].$separator.$board['privilege'].$separator.$board['category'].$separator.$label_en.$separator.$label_ch.$separator.$board['index'].$separator.$board['showmode'].$separator.$board['maxrecords'].$separator.$board['liststyle'].$separator.$board['specialcode'].$separator;
		fwrite($h,"$str\n");
		$manager=trim($board['manager']);
		if(strlen($manager)>1) $manager=$manager.$separator;
		fwrite($h,"$manager\n");
		$specialgroup=trim($board['specialgroup']);
		if(strlen($specialgroup)>1) $specialgroup=$specialgroup.$separator;
		fwrite($h,"$specialgroup\n");
		$specialuser=trim($board['specialuser']);
		if(strlen($specialuser)>1) $specialuser=$specialuser.$separator;
		fwrite($h,"$specialuser\n");
		fwrite($h,rawurlencode(trim($board['description']))."$separator\n");
		fwrite($h,$datacover_symbol[1]."\n");
		break;
	  case 2: //mod
		$str=$board['id'].$separator.$board['lastmod'].$separator.$board['status'].$separator.$board['privilege'].$separator.$board['category'].$separator.$label_en.$separator.$label_ch.$separator.$board['index'].$separator.$board['showmode'].$separator.$board['maxrecords'].$separator.$board['liststyle'].$separator.$board['specialcode'].$separator."\n";
		$lines[$idline]=$str;
		$manager=trim($board['manager']);
		if(strlen($manager)>1) $manager=$manager.$separator;
		$lines[$idline+1]="$manager\n";
		$specialgroup=trim($board['specialgroup']);
		if(strlen($specialgroup)>1) $specialgroup=$specialgroup.$separator;
		$lines[$idline+2]="$specialgroup\n";
		$specialuser=trim($board['specialuser']);
		if(strlen($specialuser)>1) $specialuser=$specialuser.$separator;
		$lines[$idline+3]="$specialuser\n";
		$lines[$idline+4]=rawurlencode(trim($board['description']))."$separator\n";
		for($i=0;$i<count($lines);$i++) fwrite($h,$lines[$i]);	
		break;
	  case 3: //del
		$delline1=$idline;
		$delline2=$idline+4;
		for($i=0;$i<count($lines);$i++)
		{
			if($i>=$delline1 && $i<=$delline2) continue;
			fwrite($h,$lines[$i]);
		}
	}
	fclose($h);
	return true;
}

function loadboardinfo($boardinfofile,&$articlesinfo,&$errinfo)
{
	global $datacover_symbol,$separator;
	$lunit=7;
	
	if(!file_exists($boardinfofile))
	{
		$directory=substr($boardinfofile,0,strrpos($boardinfofile,'/'));
		if(!is_dir($directory))
		{
			$errinfo="Access to board error!";
			return false;
		}
   	$h=fopen($boardinfofile,'w');
    if($h)
    {
    	fwrite($h,$datacover_symbol[0]."\n");
		 	fwrite($h,$datacover_symbol[1]."\n");
     	fclose($h);
    }
    else
    {
    	$errinfo="Can't create list file!";
    	return false;
    }
	}
	$articlesinfo=array();
	$lines=file($boardinfofile);
	$lnum=round((count($lines)-2)/$lunit);

	$id=array();
	$pid=array(); //parent id
	$rid=array(); //response id
	$bid=array(); //board id
	$lastmod=array();
	$privilege=array();
	$level=array();	//0:hidden; 1:regular; 2:importance; 3:collection, 4:cream
	$settop=array(); //1: top
	$ip=array();
	$pmode=array();
	$specialuser=array();
	$specialgroup=array();
	$specialcode=array();
	$author=array();
	$title=array();
	$picture=array();
	$attachment=array();
	for($i=0;$i<$lnum;$i++)
	{
		$l=$i*$lunit+1;
		$str=explode($separator,trim($lines[$l]));
		array_push($id,$str[0]);
		array_push($pid,$str[1]);
		array_push($bid,$str[2]);
		array_push($lastmod,$str[3]);
		array_push($privilege,$str[4]);
		array_push($level,$str[5]);
		array_push($settop,$str[6]);
		array_push($ip,$str[7]);
		$scode=explode($separator,rawurldecode($str[8]));
		array_push($specialcode,$scode);
		array_push($rid,$str[9]);
		array_push($pmode,$str[10]);
		$str=explode($separator,trim($lines[$l+1]));
		for($j=0;$j<count($str)-1;$j++)	$str[$j]=strtolower(trim($str[$j]));
		array_push($specialuser,$str);
		$str=explode($separator,trim($lines[$l+2]));
		for($j=0;$j<count($str)-1;$j++)	$str[$j]=strtolower(trim($str[$j]));
		array_push($specialgroup,$str);
		$str=explode($separator,trim($lines[$l+3]));
		for($a=0;$a<count($str);$a++)	$str[$a]=rawurldecode($str[$a]);
		array_push($author,$str);
		$str=trim($lines[$l+4]);
		array_push($title,$str);
		$str=trim($lines[$l+5]);
		if($str!=null)
		{
			$str=explode($separator,$str);
			sort($str);
		}
		else $str=null;
		array_push($picture,$str);
		$str=trim($lines[$l+6]);
		if($str!=null)
		{
			$str=explode($separator,$str);
			sort($str);
		}
		else $str=null;
		array_push($attachment,$str);
	}
	$articlesinfo=array("id"=>$id,"rid"=>$rid,"pid"=>$pid,"bid"=>$bid,"lastmod"=>$lastmod,
								"privilege"=>$privilege,"level"=>$level,"settop"=>$settop,"ip"=>$ip,
								"author"=>$author,"title"=>$title,"specialuser"=>$specialuser,
								"specialgroup"=>$specialgroup,"specialcode"=>$specialcode,
								"picture"=>$picture,"attachment"=>$attachment,"mode"=>$pmode);
	return true;
}

function writeboardinfo($boardpath,$boardinfofile,$articlesinfo,$mode,&$errinfo)
//1: add; 2: mod; 3: del; 4: del file
{
	global $datacover_symbol,$separator, $attachflag, $miniaturedir, $posterfileext;
	$lunit=7;
	
	$lines=file($boardinfofile);
	$lnum=round((count($lines)-2)/$lunit);
	array_pop($lines);
	array_shift($lines);

	if($mode>1)
	{
		$selectedn=-1;
		for($i=0;$i<$lnum;$i++)
		{
			$l=$i*$lunit;
			$str=explode($separator,$lines[$l]);
			if($str[0]==$articlesinfo['id'])
			{
				$selectedn=$l;
				break;
			}
		}
		if($selectedn<0)
		{
			$errinfo=$articlesinfo['id']."No matched record!";
			return false;
		}
	}
	if($mode<=4)
	{
		$contentfile="$boardpath/".$articlesinfo['id'].".$posterfileext";
		if($mode==1 || ($mode==2 && isset($articlesinfo['content']) && $articlesinfo['content']!==false))
		{
			$h=fopen($contentfile,'w');
			if($h===false)
			{
				$errinfo="Can't post article!";
				return false;
			}
	   	fwrite($h,$datacover_symbol[0]."\n");
			fwrite($h,$articlesinfo['content']."\n");
	 		fwrite($h,$datacover_symbol[1]."\n");
			fclose($h);
		}
		elseif($mode==3 || $mode==4)
		{
			if($mode==3)
			{
				if(unlink($contentfile)===false)
				{
					$errinfo="Can't delete the poster file!";
					return false;
				}
			}
			$files=trim($lines[$selectedn+5]);
			if($files!=null)
			{
				$files=explode($separator,$files);
				for($j=0;$j<count($files);$j++)
				{
					if($mode==4)
					{
						if(array_search($files[$j],$articlesinfo['picture'])===false) continue;
					}
					$file=$articlesinfo['materialdir']."/".$articlesinfo['id'].$attachflag[1].rawurldecode($files[$j]);
					$miniaturelabel=rawurldecode($files[$j]);
					$miniaturelabel=substr($miniaturelabel,0,strrpos($miniaturelabel,".")).".jpg";
					$miniature=$articlesinfo['materialdir']."/$miniaturedir/".$articlesinfo['id'].$attachflag[2].$miniaturelabel;
					if(unlink($file)===false)
					{
						$errinfo="Can't delete the posted picture: ".rawurldecode($files[$j])."!";
						return false;						
					}
					if(file_exists($miniature)) unlink($miniature);
					$files[$j]="";
				}
				if($mode==4)
				{
					$str="";
					for($j=0;$j<count($files);$j++)	if($files[$j]!="") $str=$str.$separator.$files[$j];
					if(strlen($str)>1) $str=substr($str,1);
					$lines[$selectedn+5]="$str\n";
				}
			}
			$files=trim($lines[$selectedn+6]);
			if($files!=null)
			{
				$files=explode($separator,$files);
				for($j=0;$j<count($files);$j++)
				{
					if($mode==4)
					{
						if(array_search($files[$j],$articlesinfo['attachment'])===false) continue;
					}
					$file=$articlesinfo['materialdir']."/".$articlesinfo['id'].$attachflag[0].rawurldecode($files[$j]);
					if(unlink($file)===false)
					{
						$errinfo="Can't delete the posted attachment: ".rawurldecode($files[$j])."!";
						return false;						
					}
					$files[$j]="";
				}
				if($mode==4)
				{
					$str="";
					for($j=0;$j<count($files);$j++)	if($files[$j]!="") $str=$str.$separator.$files[$j];
					if(strlen($str)>1) $str=substr($str,1);
					$lines[$selectedn+6]="$str\n";
				}
			}
		}
	}

	$startn=0;
	switch($mode)
	{
		case 1:	//add
			$str=implode($separator,array($articlesinfo['id'],$articlesinfo['pid'],$articlesinfo['bid']
									,$articlesinfo['lastmod'],$articlesinfo['privilege'],$articlesinfo['level']
									,$articlesinfo['settop'],$articlesinfo['ip'],$articlesinfo['specialcode']
									,$articlesinfo['rid'],$articlesinfo['mode']));
			array_push($lines,"$str\n");
			$str=trim($articlesinfo['specialuser']);
			array_push($lines,"$str\n");
			$str=trim($articlesinfo['specialgroup']);
			array_push($lines,"$str\n");
			$str=$articlesinfo['author'];
			array_push($lines,"$str\n");
			array_push($lines,$articlesinfo['title']."\n");
			for($j=0;$j<count($articlesinfo['picture']);$j++)	$articlesinfo['picture'][$j]=rawurlencode($articlesinfo['picture'][$j]);
			$str=array_unique($articlesinfo['picture']);
			$str=implode($separator,$str);
			array_push($lines,"$str\n");
			for($j=0;$j<count($articlesinfo['attachment']);$j++)	$articlesinfo['attachment'][$j]=rawurlencode($articlesinfo['attachment'][$j]);
			$str=array_unique($articlesinfo['attachment']);
			$str=implode($separator,$str);
			array_push($lines,"$str\n");
			break;
		case 2: //mod
			$str=implode($separator,array($articlesinfo['id'],$articlesinfo['pid'],$articlesinfo['bid']
									,$articlesinfo['lastmod'],$articlesinfo['privilege'],$articlesinfo['level']
									,$articlesinfo['settop'],$articlesinfo['ip'],$articlesinfo['specialcode']
									,$articlesinfo['rid'],$articlesinfo['mode']));
			$lines[$selectedn]="$str\n";
			if(isset($articlesinfo['specialuser']))
			{
				$str=trim($articlesinfo['specialuser']);
				$lines[$selectedn+1]="$str\n";
			}
			if(isset($articlesinfo['specialgroup']))
			{
				$str=trim($articlesinfo['specialgroup']);
				$lines[$selectedn+2]="$str\n";
			}
			if(isset($articlesinfo['author']))
			{
				$lines[$selectedn+3]=$articlesinfo['author']."\n";
			}
			if(isset($articlesinfo['title']))
			{
				$lines[$selectedn+4]=$articlesinfo['title']."\n";
			}
			if(isset($articlesinfo['picture']))
			{
				for($j=0;$j<count($articlesinfo['picture']);$j++)	$articlesinfo['picture'][$j]=rawurlencode($articlesinfo['picture'][$j]);
				$str=trim($lines[$selectedn+5]);
				if($str==null) $str=$articlesinfo['picture'];
				else
				{
					$str=explode($separator,$str);
					$str=array_merge($str,$articlesinfo['picture']);				
				}
				$str=array_unique($str);
				$str=implode($separator,$str);
				$lines[$selectedn+5]="$str\n";
			}
			if(isset($articlesinfo['attachment']))
			{
				for($j=0;$j<count($articlesinfo['attachment']);$j++)	$articlesinfo['attachment'][$j]=rawurlencode($articlesinfo['attachment'][$j]);
				$str=trim($lines[$selectedn+6]);
				if($str==null) $str=$articlesinfo['attachment'];
				else
				{
					$str=explode($separator,$str);
					$str=array_merge($str,$articlesinfo['attachment']);				
				}
				$str=array_unique($str);
				$str=implode($separator,$str);
				$lines[$selectedn+6]="$str\n";
			}
			break;
		case 3: //del
			if($selectedn>0)
			{
				$lines[$selectedn]=$lines[0];
				$lines[$selectedn+1]=$lines[1];
				$lines[$selectedn+2]=$lines[2];
				$lines[$selectedn+3]=$lines[3];
				$lines[$selectedn+4]=$lines[4];
				$lines[$selectedn+5]=$lines[5];
				$lines[$selectedn+6]=$lines[6];
			}
			$startn=$lunit;
			break;
		case 4: //del file
			//have been done earlier.
			break;
	}
	if($mode<1 || $mode>4)
	{
		$errinfo="Invalid operation!";
		return false;
	}
	else
	{
		$h=fopen($boardinfofile,'w');
		if($h===false)
		{
			$errinfo="Can't open data file to write!";
			return false;
		}
   	fwrite($h,$datacover_symbol[0]."\n");
		for($i=$startn;$i<count($lines);$i++)	fwrite($h,$lines[$i]);
	 	fwrite($h,$datacover_symbol[1]."\n");
		fclose($h);
	}
	return true;

}

function uploadfile($loadedfile,$id,$dir,$mode,&$uldfnames,&$errinfo)
//mode: 0-attachment; 1-picture; 11-packaged pictures
{
	global $upload_file_size_max, $upload_timeout, $attachflag, $forbidden_ftype, $miniaturedir, $allowed_package_type, $picture_types;

	$sizemax=$upload_file_size_max;
	$timeout=$upload_timeout;
	set_time_limit($timeout);
	$file=strtolower($loadedfile['name']);
	$fext=strtolower(substr($file,strrpos($file,".")+1));
	for($i=0;$i<count($forbidden_ftype);$i++)
	{
		$forbidden=strpos($fext,strtolower($forbidden_ftype[$i]));
		if($forbidden!==false)
		{
			$errinfo=".".$forbidden_ftype[$i]." files are forbidden to upload!";
			return false;
		}
	}

	if($mode==1)
	{
		if(array_search($fext,$picture_types)===false && array_search($fext,$allowed_package_type)===false)
		{
			$errinfo="The uploaded file is not an allowed type of picture or package!";
 			unlink($loadedfile['tmp_name']);
			set_time_limit(30);
			return false;			
		}
		if(array_search($fext,$allowed_package_type)!==false)	$mode=$mode+10;
	}

	if($mode==11)  $flag=$attachflag[1];
	else $flag=$attachflag[$mode];
	$uldfnames=array($file);
  $upfilename="$dir/$id$flag$file";
  
	if($loadedfile['size']/(1024*1024)>$sizemax)
	{
		$errinfo="Too large to upload!";
 		unlink($loadedfile['tmp_name']);
		set_time_limit(30);
		return false;
	}
	else
	{
		if(!is_dir($dir))
		{
			mkdir($dir);
			touch("$dir/index.htm");
		}
		if(!is_dir($dir))
		{
			$errinfo="Can't create data directory!";
			unlink($loadedfile['tmp_name']);
			set_time_limit(30);
			return false;
		}
		if(!is_dir("$dir/$miniaturedir"))
		{
			mkdir("$dir/$miniaturedir");
			touch("$dir/$miniaturedir/index.htm");			
		}
		if($loadedfile['size'] <1024) //ļС
		{
			$filesize=$loadedfile['size']."Bytes";
		}
		elseif ($loadedfile['size'] <(1024 * 1024))
		{
			$filesize=strval($loadedfile['size']/1024)."KB";
		}
		else
		{
			$filesize=strval($loadedfile['size']/(1024 * 1024))."MB";
		}
		if($mode<10)
		{
			if(!file_exists($upfilename))
			{
				if(copy($loadedfile["tmp_name"],$upfilename))
				{
	 				unlink($loadedfile['tmp_name']);
					set_time_limit(30);
					return true;
				}
 				$errinfo="Failed to Upload!";
 				unlink($loadedfile['tmp_name']);
 				set_time_limit(30);
 				return false;
 			}
  		$errinfo="The file already exists!";
			unlink($loadedfile['tmp_name']);
 			set_time_limit(30); //ָȱʡʱ
 			return false;
  	}
  	else
  	{
			$tmpdir=$loadedfile["tmp_name"].".dir";
			if(!mkdir($tmpdir))
			{
				$errinfo("Error when unpacking!");
	 			unlink($loadedfile['tmp_name']);
	 			set_time_limit(30);
 				return false;				
			}
			$newloadedfile="$tmpdir/package.".$fext;
			if(!copy($loadedfile["tmp_name"],$newloadedfile))
			{
				$errinfo("Error when unpacking!");
	 			unlink($loadedfile['tmp_name']);
	 			rmdir($tmpdir);
	 			set_time_limit(30);
 				return false;									
			}

			//unzip -jo *.zip
			//unrar e -o+ -inul *.rar
			switch($fext)
			{
				case "zip":
					$command="unzip -jo \"$newloadedfile\" -d \"$tmpdir\"";
					break;
				case "rar":
					$command="unrar e -o+ -inul \"$newloadedfile\"";
					break;
			}
			//$errinfo=$command;
			//return false;
			exec($command);

			$handle = opendir($tmpdir);
			if($handle===false)
			{
				$errinfo("Error when unpacking!");
	 			unlink($loadedfile['tmp_name']);
	 			unlink($newloadedfile);
	 			//unlink($tmpdir);
	 			set_time_limit(30);
 				return false;									
			}

			$uldfnames=array();
			while (false !== ($tmpfile = readdir($handle))) 
			{
				if($tmpfile=="." || $tmpfile=="..") continue;
				$pos=strrpos($tmpfile,".");
				$ext=strtolower(substr($tmpfile,$pos+1));
				if(array_search($ext,$picture_types)!==false)
				{
					$tmpfile1=strtolower($tmpfile);
					array_push($uldfnames,$tmpfile1);
					$newfile="$dir/$id$flag$tmpfile1";
					rename("$tmpdir/$tmpfile",$newfile);
				}
				else unlink("$tmpdir/$tmpfile");
    	}
			closedir($handle);
			rmdir($tmpdir);
 			unlink($loadedfile['tmp_name']);
			set_time_limit(30);
			return true;
  	}
  }
}

function sumcontent($content)
{
	$sum=0;
	$str='';
	$llen=count($content);
	for($i=0;$i<$llen;$i++)
	{
		$str=$str.$content[$i];
	}
	$clen=strlen($str);
  for($i=0;$i<$clen;$i++)
  {
  	$sum=$sum+$str[$i];
  }
	return array("llen"=>$llen,"clen"=>$clen,"sum"=>$sum);
}

function article_tree(&$articlesinfo,$root,&$tree)
{
	$selname='rid';
	$tree=array($root,array(),array());
	$id=$articlesinfo['id'][$root];
	$keys=array_keys($articlesinfo[$selname],$id);
	$nkeys=array();
	if($keys!=null)
	{
		for($i=0;$i<count($keys);$i++)
		{
			if($keys[$i]!=$root) array_push($nkeys,$keys[$i]);
		}
	}
	$keys=$nkeys;
	if($keys!=null)
	{
		if($articlesinfo['mode'][$root]=='2') $tree[2]=array_merge($tree[2],$keys);
		else
			for($k=0;$k<count($keys);$k++)
			{
				if($articlesinfo['mode'][$keys[$k]]=='2') array_push($tree[2],$keys[$k]);
				else array_push($tree[1],$keys[$k]);
			}
		$sortarr=array();
		for($i=0;$i<count($tree[1]);$i++)
		{
			$subtree=$tree[1][$i];
			article_tree($articlesinfo,$subtree,$tree[1][$i]);
			array_push($sortarr,$articlesinfo['id'][$tree[1][$i][0]]);
		}
		array_multisort($sortarr,SORT_ASC,$tree[1]);
		
		for($i=0;$i<count($tree[2]);$i++)
		{
			$subtree=$tree[2][$i];
			article_tree($articlesinfo,$subtree,$tree[2][$i]);
		}
		array_dimension_reduce($tree[2],$tree[2]);
		$sortarr=array();
		for($i=0;$i<count($tree[2]);$i++)
		{
			array_push($sortarr,$articlesinfo['id'][$tree[2][$i]]);
		}
		array_multisort($sortarr,SORT_DESC,$tree[2]);
	}
}


function array_dimension_reduce($array,&$reduced,$n=0)
{
	if($n==0) $reduced=array();
	for($i=0;$i<count($array);$i++)
	{
		if(is_array($array[$i])) array_dimension_reduce($array[$i],$reduced,$n+1);
		elseif($array[$i]!=null) array_push($reduced,$array[$i]);
	}
}

?>
