<?php
function loadusersinfo($pwdfile,$mode,&$errinfo)
{
	global $account_item_total_num, $datacover_symbol;
	
	if(isset($_SESSION['accountsinfo']) && $mode==0)	return true;
	if(!file_exists($pwdfile))
	{
		$pwddir=dirname($pwdfile);
		if(!is_dir($pwddir))
		{
			mkdir($pwddir);
			touch("$pwddir/index.htm");
		}
		if(!is_dir($pwddir))
		{
                        $errinfo="Can't create password file!";
                        return false;
		}
		$h=fopen($pwdfile,'w');
		if($h===false)
		{
			$errinfo="Can't create password file!";
			return false;
		}
		fwrite($h,$datacover_symbol[0]."\n");
		fwrite($h,"#accountname:password:status:userid:group:changepasswd:title:name:sign up datetime:last login datetime:last login IPaddress:login times:security code:functions:entrance:description:shortname:\n");
		$time=time();
		fwrite($h,"root:$1\$xAhjIlbn$7iUtdrAUquthXuZkFm7sJ/:1:0:0:1:101:Root|%B9%DC%C0%ED%D4%B1::1157320711:127.0.0.1:3:$1$.zrwpsc5\$qL3LXwbLq8EsB4ndrQMhX1:01&10:-:Administrator::\n"); //root@cOpfOs ; cOpfOs
		fwrite($h,$datacover_symbol[1]."\n");
		fclose($h);
		chmod($pwdfile,0600);
	}
	clearstatcache();
	$lastcache=filemtime($pwdfile);
	if(isset($_SESSION['accountsinfo']) && $_SESSION['accountsinfo']['lastcache']==$lastcache) return true;

	$lines=file($pwdfile);
	$lnum=count($lines)-3;
	if($lnum<=0) 
	{
		$errinfo="No account!";
		return false;
	}
	
	$account=array();
	$name=array();
	$shortname=array();
	$userid=array();
	$group=array();
	$title=array();
	$status=array();
	$entrance=array();
	$function=array();
	$description=array();
	for($i=0;$i<$lnum;$i++)
	{
	  if($lines[$i+2][0]=='#') continue;
		$str=explode(":",$lines[$i+2]);
	  if(count($str)<$account_item_total_num) continue;
	  
		array_push($account,$str[0]);
		$thisname=explode("|",$str[7]);
		for($j=0;$j<count($thisname);$j++) $thisname[$j]=rawurldecode($thisname[$j]);
		if(count($thisname)==1) $thisname=array($thisname[0],$thisname[0]);
		$commapos=strpos($thisname[0],",");
		if($commapos!==false)
		{
			$familyname=substr($thisname[0],0,$commapos);
			$firstname=substr($thisname[0],$commapos+1);
			$thisname[0]=$firstname." ".$familyname;
		}
		array_push($name,$thisname);
		array_push($userid,$str[3]);
		array_push($group,explode("&",$str[4]));
		array_push($title,explode("&",$str[6]));
		array_push($status,$str[2]);
		array_push($function,explode("&",$str[13]));
		array_push($entrance,$str[14]);
		$thisdes=explode("|",$str[15]);
		for($j=0;$j<count($thisdes);$j++) $thisdes[$j]=rawurldecode($thisdes[$j]);
		if(count($thisdes)==1) $thisdes=array($thisdes[0],$thisdes[0]);
		array_push($description,$thisdes);
		array_push($shortname,rawurldecode(trim($str[16])));
	}
	$accountsinfo=array("account"=>$account,"name"=>$name,"shortname"=>$shortname,"uid"=>$userid,"gid"=>$group,
										"title"=>$title,"status"=>$status,"function"=>$function,"entrance"=>$entrance,"description"=>$description);

	$index=array();
	for($i=0;$i<count($accountsinfo['account']);$i++)
	{
		$name=strtoupper($accountsinfo['name'][$i][0]);
		$spacepos=strrpos($name," ");
		if($spacepos!==false)
		{
			$familyname=substr($name,$spacepos+1);
			$name=$familyname.", ".substr($name,0,$spacepos);
		}
		array_push($index,$name);
	}
	
	if($index!=null)	array_multisort($index, SORT_ASC, $accountsinfo['account'], $accountsinfo['name'], $accountsinfo['shortname'], $accountsinfo['uid'], $accountsinfo['gid'], $accountsinfo['title'], $accountsinfo['status'], $accountsinfo['function'], $accountsinfo['entrance'], $accountsinfo['description']);

	$_SESSION['accountsinfo']=array_merge($accountsinfo,array("lastcache"=>$lastcache));
	
	return true;
}


function permission($allowuserlist,$allowgrouplist,$entrance,$pre_permission,$mode,$test)
//$mode: 0-denied if no list file; 1-passed if no list file
//$test: 1-not change to $_SESSION['permission']
//return value: 0-denied/anonymous; 1-readonly; 2-writable
{
//	global $anonymousgroup;
	if(!isset($_SESSION['uid'])) return 0;
	if($_SESSION['account']=="root") 
	{
		$_SESSION['permission']=2;
		return 2;
	}
	if(strlen($entrance)>2 && $entrance==$_SESSION['entrance'])// && $_SESSION['group'][0]!=$anonymousgroup)	
	{
		if($pre_permission<0) $pre_permission=2;
		else $pre_permission=min($pre_permission,2);
		$permissionlevel=2;
	}
	else 
	{
		if($pre_permission<0) $pre_permission=1;
		else $pre_permission=min($pre_permission,1);
		$permissionlevel=1;
	}
	
	$uallowed=true;
	$nouserlist=0;
	$upermissionlevel=$permissionlevel;
	if($allowuserlist!=null) $uallowed=false;
	if(file_exists($allowuserlist))
	{
		$uallowed=false;
		if(isset($_SESSION['account']))
		{
		$allowusers=file($allowuserlist);
		for($i=0;$i<count($allowusers);$i++)
		{
			$allowuser=explode(":",$allowusers[$i]);
			if(count($allowuser)>1)
			{
				$permissionlevel=trim($allowuser[1]);
			}
			else $permissionlevel=1;  //readonly
			$allowuser=strtolower(trim($allowuser[0]));
			if($_SESSION['account']==$allowuser)
			{
				$upermissionlevel=$permissionlevel;
				$uallowed=true;
				break;
			}
		}
		}
	}
	else 
	{
		$nouserlist=1;
		if($mode==1)	$uallowed=true;
	}

	$gallowed=true;
	$nogrouplist=0;
	$gpermissionlevel=$permissionlevel;
	if($allowgrouplist!=null) $gallowed=false;
	if(file_exists($allowgrouplist))
	{
		$gallowed=false;
		if(isset($_SESSION['group']))
		{
		$allowgroups=file($allowgrouplist);
		for($i=0;$i<count($allowgroups);$i++)
		{
			$allowgroup=explode(":",$allowgroups[$i]);
			if(count($allowgroup)>1)
			{
				$permissionlevel=trim($allowgroup[1]);
			}
			else $permissionlevel=1;
			$allowgroup=strtolower(trim($allowgroup[0]));
			if(array_search($allowgroup,$_SESSION['group'])!==false)
			{
				$gpermissionlevel=$permissionlevel;
				$gallowed=true;
				break;
			}
		}
		}
	}
	else
	{
		$nogrouplist=1;
		if($mode==1)	$gallowed=true;
	}

	if($gallowed===true || $uallowed===true)
	{
		if($gallowed===true && $uallowed===true) 
		{
			$permissionmax=max($upermissionlevel,$gpermissionlevel);
			if($nogrouplist) $gpermissionlevel=$permissionmax;
			if($nouserlist) $upermissionlevel=$permissionmax;
			$permissionlevel=min($upermissionlevel,$gpermissionlevel);
		}
		elseif ($gallowed===true) $permissionlevel=$gpermissionlevel;
		else $permissionlevel=$upermissionlevel;
	}
	else $permissionlevel=0;

//echo "$entrance:$pre_permission:$permissionlevel<br>";
  if($pre_permission>=0) $permissionlevel=min($permissionlevel,$pre_permission);
	if($test==0 && isset($_SESSION['account'])) $_SESSION['permission']=$permissionlevel;
	return $permissionlevel;
}

function username_rulematch(&$username, &$errinfo)
{
	if($username=="root") return true;
	$usernameminlen=3;
	$username=strtolower(trim($username));
	if(strlen($username)<$usernameminlen) 
	{
		$errinfo="Account name must be a valid email address!";
		return false; //username too short
	}
	if(strpos($username,"@")<1 || strpos($username,"@")>=strlen($username)-1) 
	{
		$errinfo="Account name must be a valid email address!";
		return false;
	}
	if(strpos($username,"/")!==false || strpos($username,"\\")!==false)
	{
		$errinfo="Account name must be a valid email address!";
		return false;
	}
	if(strpos($username,":")!==false)
	{
		$errinfo="Account name must be a valid email address!";
		return false;
	}
	return true;	
}
function password_rulematch(&$password, &$errinfo)
{
	global $password_minlen;
	$passwordminlen=$password_minlen;
	$password=trim($password);
	if(strlen($password)<$passwordminlen)
	{
		$errinfo="Password or security code must be not shorter than $passwordminlen characters!";
		return false; //password too short
	}
	return true;	
}

function login($username,$password,$pwdfile,$itemnum,&$errinfo)//,$allowlist)
{
	$username=strtolower(trim($username));
	if(username_rulematch($username, $errinfo)!=1) 
	{
		return 1; //username rule not matched
	}
	if(!file_exists($pwdfile)) 
	{
		$errinfo="System Error: No password file!";
		return 2; //no pwdfile
	}
	$pwdlist=file($pwdfile);
	for($i=0;$i<count($pwdlist);$i++)
	{
		$record=$pwdlist[$i];
		if($record[0]=='#') continue;
		$info=explode(":",$record);
		if(count($info)<$itemnum) continue;
		$thisid=strtolower(trim($info[0]));
		if($thisid!=$username) continue;
		if(trim($info[2])!=1 && trim($info[2])!=2)
		{
			$errinfo="Your account is locked!";
			return (trim($info[2])+10); //status error
		}
		$thispwd=trim($info[1]);
		if($thispwd!=null && crypt($password,$thispwd)!=$thispwd)
		{
			$errinfo="Password is incorrect!";
			return 3; //password not matched
		}
		$_SESSION['account']=$thisid;
		$logintimes=trim($info[11])+1;
		$_SESSION['logintimes']=$logintimes;
		$_SESSION['secode']=trim($info[12]);
		$name=explode("|",trim($info[7]));
		for($j=0;$j<count($name);$j++) $name[$j]=rawurldecode($name[$j]);
		if(count($name)==1) $_SESSION['name']=array($name[0],$name[0]); else $_SESSION['name']=$name;
		$_SESSION['title']=explode("&",trim($info[6]));
		$_SESSION['email']=$thisid;
		$_SESSION['status']=trim($info[2]);
		$_SESSION['uid']=trim($info[3]);
		$_SESSION['group']=explode("&",trim($info[4]));
		$_SESSION['chpwd']=trim($info[5]);
		$_SESSION['signupdt']=trim($info[8]);
		$_SESSION['lastindt']=trim($info[9]);
		$_SESSION['lastinip']=trim($info[10]);
		$_SESSION['functions']=trim($info[13]);
		$_SESSION['entrance']=trim($info[14]);
		$description=explode("|",trim($info[15]));
		for($j=0;$j<count($description);$j++) $description[$j]=rawurldecode($description[$j]);
		if(count($description)==1) $_SESSION['description']=array($description[0],$description[0]); else $_SESSION['description']=$description;
		$_SESSION['shortname']=rawurldecode(trim($info[16]));
		$curdatetime=time();
		$curip=$_SERVER['REMOTE_ADDR'];
		$items=array(false,false,false,false,false,false,false,false,false,$curdatetime,$curip,$logintimes,false,false,false,false,false,array("","",""));
		updatepwdf($pwdfile,$thisid,$itemnum,$items,0,$errinfo);
		if(isset($_SESSION['scode'])) unset($_SESSION['scode']);
  	return 0; //success
	}
	$errinfo="No this account!";
	return 4; //no username
}
/*
$login_error_info=array(0=>array("",""),1=>array("This is not a valid username","Чʺ"),2=>array("InnerError","ڲ"),
	3=>array("Password is not correct",""),4=>array("This is not a valid username","Чʺ"),10=>array("Unproved","δ"),
	13=>array("Locked",""));
*/

function logout()
{
	if(isset($_SESSION['account'])) unset($_SESSION['account']);
	if(isset($_SESSION['secode'])) unset($_SESSION['secode']);
	if(isset($_SESSION['name'])) unset($_SESSION['name']);
	if(isset($_SESSION['title'])) unset($_SESSION['title']);
	if(isset($_SESSION['email'])) unset($_SESSION['email']);
	if(isset($_SESSION['status'])) unset($_SESSION['status']);
	if(isset($_SESSION['uid'])) unset($_SESSION['uid']);
	if(isset($_SESSION['group'])) unset($_SESSION['group']);
	if(isset($_SESSION['chpwd'])) unset($_SESSION['chpwd']);
	if(isset($_SESSION['signupdt'])) unset($_SESSION['signupdt']);
	if(isset($_SESSION['lastindt'])) unset($_SESSION['lastindt']);
	if(isset($_SESSION['lastinip'])) unset($_SESSION['lastinip']);
	if(isset($_SESSION['logintimes'])) unset($_SESSION['logintimes']);
	if(isset($_SESSION['permission'])) unset($_SESSION['permission']);
	if(isset($_SESSION['functions'])) unset($_SESSION['functions']);
	if(isset($_SESSION['entrance'])) unset($_SESSION['entrance']);
	if(isset($_SESSION['description'])) unset($_SESSION['description']);
	if(isset($_SESSION['shortname'])) unset($_SESSION['shortname']);
	if(isset($_SESSION['scode'])) unset($_SESSION['scode']);
}

function generate_password(&$unencoded_password)
{
	global $password_minlen;
	$unencoded_password="";
	for($i=0;$i<$password_minlen;$i++)
	{
		$pos=rand(48,122);
		if(array_search($pos,array(60,62,92))!==false)
		{
			$i--;
			continue;
		}
		$unencoded_password.=chr($pos);
	}
	$password=crypt($unencoded_password);
	return $password;
}

function updatepwdf($pwdfile,$userid,$itemnum,$items,$mode,&$errinfo)
{
	global $rootdir, $userhomedir, $deleteddir, $datacover_symbol;
	//if(!isset($_SESSION['account'])) return 1; //not logged
	if(!file_exists($pwdfile))
	{
		$h=fopen($pwdfile,'w');
		if(!$h)
		{
			$errinfo="Can not create the PWD file!";
			return false;
		}
		if(flock($h,LOCK_EX))
		{
			fwrite($h,$datacover_symbol[0]."\n");
			fwrite($h,$datacover_symbol[1]."\n");
			fclose($h);
		}
		else
		{
			fclose($h);
			unlink($pwdfile);
			$errinfo="Can not create the PWD file!";
			return false;
		}
	}
	if(count($items)<$itemnum)
	{
		$errinfo="No enough items in the PWD file!";
		return false;		
	}
	$idcode=trim($items[3]);
	$pwdlist=file($pwdfile);
	$update=0;
	switch ($mode)
	{
		case 0:	//mod
			$userid_duplicated=0;
			for($i=0;$i<count($pwdlist);$i++)
			{
				$record=$pwdlist[$i];
				if($record[0]=='#') continue;
				$info=explode(":",$record);
				if(count($info)<$itemnum) continue;
				$thisid=strtolower(trim($info[0]));
				if($thisid!=$userid) continue;
				
				for($j=0;$j<count($pwdlist);$j++)
				{
					if($j==$i) continue;
					$record1=$pwdlist[$j];
					if($record1[0]=='#') continue;
					$info1=explode(":",$record1);
					if(count($info1)<$itemnum) continue;
					$thisid1=strtolower(trim($info1[0]));
					$thisshortname=trim($info1[16]);
					if($thisid1==strtolower(trim($items[0])) || ($idcode!="" && trim($info1[3])==$idcode) || ($items[16]!=false && $thisshortname==trim($items[16])))
					{
						$userid_duplicated++;
					}
					if($userid_duplicated)
					{
						$errinfo="Duplicated Account or User ID!";
						return false;
					}
				}
				
				for($j=0;$j<$itemnum;$j++)
				{
					if($j==3)
					{
						if($info[3]=="") $info[3]=gmdate("YmdHis",$info[8]).".".rand_ns(3);
						continue;
					}
					if($j==14)
					{
						$userentrance_old=$info[$j];
						$userentrance_new=$items[$j];
					}
					if($items[$j]===false) continue;
					if($j==0)
					{
						if(username_rulematch($items[$j],$errinfo)) $info[$j]=$items[$j]; 
					}
					else $info[$j]=$items[$j];
				}
				$mailrecipient=$info[0];
				$mailrecipientname=rawurldecode($info[7]);
				$record=implode(":",$info);
				$pwdlist[$i]=$record;
				$update=1;

				break;
			}
			break;
		case 1:	//add
			$idcode=gmdate("YmdHis").".".rand_ns(3);
			$items[3]=$idcode;
			for($i=0;$i<count($pwdlist);$i++)
			{
				$record=$pwdlist[$i];
				if($record[0]=='#') continue;
				$info=explode(":",$record);
				if(count($info)<$itemnum) continue;
				$thisid=strtolower(trim($info[0]));
				if($thisid==$userid || ($idcode!="" && trim($info[3])==$idcode))
				{
					$errinfo="The user has existed, can not create again!";
					return false;
				}
				$thisshortname=trim($info[16]);
				if($items[16]==$thisshortname)
				{
					$errinfo="The shortname has existed!";
					return false;					
				}
			}
			for ($i=0;$i<$itemnum;$i++)
			{
				if($items[$i]===false) $items[$i]="";
				elseif($i==14) $userentrance_new=$items[$i];
				if($i==0)
				{
					if(!username_rulematch($items[$i],$errinfo))
					{
						return false;				
					} 
				}
				$info[$i]=$items[$i];
			}
			$mailrecipient=$info[0];
			$mailrecipientname=rawurldecode($info[7]);
			$record=implode(":",$info);
			$pwdlist[count($pwdlist)-1]="$record:\n";
			array_push($pwdlist,"*/ ?>\n");
			$update=1;
			break;
		case 2:	//del
			for($i=0;$i<count($pwdlist);$i++)
			{
				//if($update)
				//{
				//	$pwdlist[$i-1]=$pwdlist[$i];
				//	continue;
				//}
				$record=$pwdlist[$i];
				if($record[0]=='#') continue;
				$info=explode(":",$record);
				if(count($info)<$itemnum) continue;
				$thisid=strtolower(trim($info[0]));
				if($thisid!=$userid) continue;
				$update=1;
				$userentrance_old=$info[14];
				$pwdlist[$i]="#".$pwdlist[$i];
			}
			//array_pop($pwdlist);
			break;
	}		
		
	if(!$update)
	{
		$errinfo="Nothing to be updated!";
		return false;	
	}
	$h=fopen($pwdfile,'w');
	if(!$h)
	{
		$errinfo="Can not write into the PWD file!";
		return false;
	}
	if(flock($h,LOCK_EX))
	{
		for($i=0;$i<count($pwdlist);$i++)
		{
			fwrite($h,$pwdlist[$i]);
		}
	}
	else $lockfailed=1;
	fclose($h);
	if($lockfailed)
	{
		$errinfo="Can not lock the PWD file!";
		return false;		
	}
	switch ($mode)
	{
		case 0:
			if(username_rulematch($items[0],$errinfo) && $userentrance_new!==false && strlen(trim($userentrance_new))>2 
				&& strpos($userentrance_new,"/")===false && $userentrance_new!=$userentrance_old)
			{
				$old_dir="$userhomedir/$userentrance_old";
				$new_dir="$userhomedir/$userentrance_new";
				if(!file_exists($userhomedir))
				{
					mkdir($userhomedir);
					touch("$userhomedir/index.htm");
				}
				if(file_exists($old_dir) && !file_exists($new_dir))
					rename($old_dir,$new_dir);
				else
					mkhomedirtree($new_dir);
			}
			break;
		case 1:
			if(username_rulematch($items[0],$errinfo) && $userentrance_new!==false && strlen(trim($userentrance_new))>2 
				&& strpos($userentrance_new,"/")===false)
			{
				if(!file_exists($userhomedir))
				{
					mkdir($userhomedir);
					touch("$userhomedir/index.htm");
				}
				$new_dir="$userhomedir/$userentrance_new";
				mkhomedirtree($new_dir);
			}
			break;
		case 2:
			$old_dir="$userhomedir/$userentrance_old";
			if(file_exists($old_dir))
			{
				if(!file_exists($deleteddir))
				{
					mkdir($deleteddir);
					touch("$deleteddir/index.htm");
				}
				rename($old_dir,"$deleteddir/$userid"."_del_".gmdate("YmdHis"));
			}
			break;
	}

	loadusersinfo($pwdfile,1,$errinfo);

	$unencoded_code=array_pop($items);
        //$unencoded_code=(passwd,secode,mode:0-mod,1-add,2-reset)
	if($unencoded_code[2]>-1)
	{
	$message1="";
	if($unencoded_code[0]!=null)
	{
		switch($unencoded_code[2])
		{
			case 1:
			  $message1="<br><br>- Your initial password is \\\"".$unencoded_code[0]."\\\".";
			  break;
			case 2:
			  $message1="<br><br>- Your password has been reset to \\\"".$unencoded_code[0]."\\\".";
			  break;
			default:
			  $message1="<br><br>- Your password has been changed.";
                          break;
		}
	}
	if($unencoded_code[1]!=null)
	{
		switch($unencoded_code[2])
		{
			case 2:
			  $message1.="<br><br>- Your security code has been reset to \\\"".$unencoded_code[1]."\\\".";
			  break;
			default:
			  $message1.="<br><br>- Your security code has been changed.";
                          break;
		}
	}

	if($message1!=null || $unencoded_code[2]==1)
	{
		  global $webrootdir, $site_title, $mailserver, $mailusername, $mailpassword, $mailsender, $mailsignature, $mailoptions, $usermanagers;
		  $now=date("H:i M-d-Y T");
	}
	if($message1!=null)
	{
		switch($unencoded_code[2])
		{
			case 1:
			  $message="Thank for your registration. Your account, $mailrecipient ($mailrecipientname), has been approved!";
			  $message.=$message1;
			  $message.="<br><br>Please login into <a href=\"$webrootdir\">$site_title</a> to change your codes.";
			  $mailsubject="$site_title Notice: Account approved!";
			  break;
			case 2:
			  $message="The password and/or security code of your account, $mailrecipient ($mailrecipientname), have/has been reset!";
			  $message.=$message1;
			  $message.="<br><br>Please login into <a href=\"$webrootdir\">$site_title</a> to change your codes.";
			  $mailsubject="$site_title Notice: Password/security code reset!";
			  break;
			default:
			  $message="The password and/or security code of your account, $mailrecipient ($mailrecipientname), have/has been changed! If it is not true, contact";
			  if(count($usermanagers)>1) $message.=" one of managers "; else $message.=" the manager ";
			  $message.=implode(", ",$usermanagers)." immediately!";
			  $message.=$message1;
			  $mailsubject="$site_title Notice: Password/security code changed!";
			  break;
		}
		$message.="<br><br>This is an automatically sending email from <a href=\"$webrootdir\">$site_title</a> at $now.<br>";
		$message.="<font color=red><b>Do NOT reply this email!</b></font>";
		$message.=$mailsignature;
		if($unencoded_code[2]!=0)
		{
			$mailrecipient=array($mailrecipient);
			if(isset($_SESSION['email']) && array_search($_SESSION['email'],$mailrecipient)===false) array_push($mailrecipient,$_SESSION['email']);
		}
		sendemail($mailserver,$mailusername,$mailpassword,$mailsender,$mailrecipient,$mailsubject,$message,$mailoptions);
	}
	elseif($unencoded_code[2]==1)
	{
		$mailsender=$mailrecipient;
		$message="A new user, $mailsender ($mailrecipientname), registered into <a href=\"$webrootdir\">$site_title</a> system.";
		$message.="<br><br>Please goto <a href=\"$webrootdir\">$site_title</a> to approve it.";
		$message.="<br><br>This is an automatically sending email from <a href=\"$webrootdir\">$site_title</a> at $now.<br>";
		$message.="<font color=red><b>Do NOT reply this email!</b></font>";
		$message.=$mailsignature;
		$mailsubject="$site_title Notice: A new user is pending for approval!";
		if($usermanagers!=null)
		{
			$mailsender=array($mailsender);
			sendemail($mailserver,$mailusername,$mailpassword,$mailsender,$usermanagers,$mailsubject,$message,$mailoptions);
		}
	}
	}
	
	return true;  //success
}

function mkhomedirtree($dir)
{
	//global $homedirtree;
	$subdirs=$homedirtree;
	if(!file_exists($dir))
	{
		mkdir($dir);
		touch("$dir/index.htm");
	}
/*
	for ($i=0;$i<count($subdirs);$i++)
	{
		$subdir=$dir."/".$subdirs[$i];
		if(!file_exists($subdir))
		{
			mkdir($subdir);
			touch("$subdir/index.htm");
		}
	}
*/
}
?>
