<?php
function mkhead($author, $charset, $title, $font, $size, $linkcolors,$underlines,$fbcolor)
{
	$underlinestr=array("none","underline");
	//$weight="bold";
?>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=<?=$charset;?>">
  <meta http-equiv="Content-Language" content="zh-cn">
  <meta name="Author" content="<?=$author;?>">
  <title><?=$title;?></title>
	<style type="text/css">
	A:link {COLOR: <?=$linkcolors[0];?>; TEXT-DECORATION: <?=$underlinestr[$underlines[0]];?>}
	A:visited {COLOR: <?=$linkcolors[1];?>; TEXT-DECORATION: <?=$underlinestr[$underlines[1]];?>}
	A:active {COLOR:<?=$linkcolors[2];?>; TEXT-DECORATION: <?=$underlinestr[$underlines[2]];?>}
	A:hover {COLOR: <?=$linkcolors[3];?>; TEXT-DECORATION: <?=$underlinestr[$underlines[3]];?>}
	BODY {FONT-WEIGHT: <?=$weight;?>; FONT-SIZE: <?=$size;?>; COLOR: <?=$fbcolor[0];?>; FONT-FAMILY:"<?=$font;?>"}
        TH {FONT-WEIGHT: <?=$weight;?>; FONT-SIZE: <?=$size;?>; COLOR: <?=$fbcolor[0];?>; FONT-FAMILY:"<?=$font;?>"}
        TD {FONT-WEIGHT: <?=$weight;?>; LINE-HEIGHT: 145%; FONT-SIZE:<?=$size;?>; COLOR: <?=$fbcolor[0];?>; FONT-FAMILY:"<?=$font;?>"}
        TABLE {FONT-WEIGHT: <?=$weight;?>; FONT-SIZE: <?=$size;?>; COLOR: <?=$fbcolor[0];?>; FONT-FAMILY:"<?=$font;?>"}
	DIV {FONT-WEIGHT: <?=$weight;?>; FONT-SIZE: <?=$size;?>; COLOR: <?=$fbcolor[0];?>; FONT-FAMILY:"<?=$font;?>"}
	FORM {FONT-WEIGHT: <?=$weight;?>; FONT-SIZE: <?=$size;?>; COLOR: <?=$fbcolor[0];?>; FONT-FAMILY:"<?=$font;?>"}
	SPAN {FONT-WEIGHT: <?=$weight;?>; FONT-SIZE: <?=$size;?>; COLOR: <?=$fbcolor[0];?>; FONT-FAMILY:"<?=$font;?>"}
	PRE 
	{
		FONT-WEIGHT: <?=$weight;?>; FONT-SIZE:<?=$size;?>; COLOR: <?=$fbcolor[0];?>; FONT-FAMILY:"<?=$font;?>";
		word-wrap: break-word;
		white-space: -moz-pre-wrap, pre-wrap, -o-pre-wrap; /* CSS2.1 compliant */
		overflow-x: auto;
	}
	.spanstyle {COLOR: #ff6600; FONT-FAMILY: Verdana; FONT-SIZE: 10pt; FONT-WEIGHT: bold; POSITION: absolute; TOP: -50px; VISIBILITY: visible}
	</style>
</head>
<body bgcolor="<?=$fbcolor[1];?>">
<?
	return;
}


?>
