<?php
function loadinfo($datafile, $cvitems, &$cvdata)//, &$errinfo)
{
	global $datacover_symbol;
	$cvdata=array();
	if(!file_exists($datafile)) 
	{
		$h=fopen($datafile,'w');
		if($h)
		{
			fwrite($h,$datacover_symbol[0]."\n");
			fwrite($h,$datacover_symbol[1]."\n");
			fclose($h);
		}
		return -1;
	}
	if(!file_exists($datafile))
	{
		$errinfo="The data file does not exist and can not create it!";
		return false;
	}
	
	$lines=file($datafile);
	$num=count($lines)-2;
	if($num<2)	return(-3);
	
	$i=2;
	if($i>$num)	return(true);
	$str1=explode("|",$lines[$i]);	$str1=$str1[1];
	$str2=explode("|",$lines[$i+1]);	$str2=$str2[1];
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[0][0]=>array("label"=>$label,"value"=>array($str1,$str2)));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=3;
	if($i>$num)	return(true);
	$str1=explode("|",$lines[$i]);	$str1=$str1[1];
	$cvsex=$str1;
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[1][0]=>array("label"=>$label,"value"=>$cvsex));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=2;
	if($i>$num)	return(true);
	$str1=explode("|",$lines[$i]);	$str1=$str1[1];
	$str2=explode("|",$lines[$i+1]);	$str2=$str2[1];
	$cvnationality=array($str1,$str2);
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[2][0]=>array("label"=>$label,"value"=>$cvnationality));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=3;
	if($i>$num)	return(true);
	$str1=explode("|",$lines[$i]);	$str1=$str1[1];
	$str2=explode("|",$lines[$i+1]);	$str2=$str2[1];
	$cvbirthplace=array($str1,$str2);
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[3][0]=>array("label"=>$label,"value"=>$cvbirthplace));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=3;
	if($i>$num)	return(true);
	$str1=explode("|",$lines[$i]);	$str1=$str1[1];
	$cvbirthdate=$str1;
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[4][0]=>array("label"=>$label,"value"=>$cvbirthdate));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=2;
	if($i>$num)	return(true);
	$j=0;
	while($j<=$num-$i)
	{
		$str1=$lines[$i+$j];
		if($str1[0]==":")	break;
		if($str1[0]=="|")
		{
			if($j==0)	
			{
				$str2="eaddress";
				$str1=substr($str1,1);
			}
			else	
			{
				$str2="caddress";
				$str1=substr($str1,1);
			}
			$$str2="";
		}
		$$str2=$$str2.$str1;
		$j++;
	}
	$eaddress=substr($eaddress,0,strrpos($eaddress,"|"));
	$caddress=substr($caddress,0,strrpos($caddress,"|"));
	$cvaddress=array($eaddress, $caddress);
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[5][0]=>array("label"=>$label,"value"=>$cvaddress));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=($j+1);
	if($i>$num)	return(true);
	$str1=explode("|",$lines[$i]);	$str1=$str1[1];
	$cvtelephone=$str1;
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[6][0]=>array("label"=>$label,"value"=>$cvtelephone));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=2;
	if($i>$num)	return(true);
	$str1=explode("|",$lines[$i]);	$str1=$str1[1];
	$cvfax=$str1;
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[7][0]=>array("label"=>$label,"value"=>$cvfax));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=2;
	if($i>$num)	return(true);
	$str1=explode("|",$lines[$i]);	$str1=$str1[1];
	$cvemail=$str1;
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[8][0]=>array("label"=>$label,"value"=>$cvemail));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=2;
	if($i>$num)	return(true);
	$str1=explode("|",$lines[$i]);	$str1=$str1[1];
	$cvhomepage=$str1;
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[9][0]=>array("label"=>$label,"value"=>$cvhomepage));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=2;
	if($i>$num)	return(true);
	$str1=explode("|",$lines[$i]);	$str1=$str1[1];
	$str2=explode("|",$lines[$i+1]);	$str2=$str2[1];
	$cvposition=array(rawurldecode($str1),rawurldecode($str2));
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[10][0]=>array("label"=>$label,"value"=>$cvposition));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=3;
	if($i>$num)	return(true);
	$j=0;
	$cvexperiences=array();
	while($j<=$num-$i)
	{
		$str2=array();
		$str1=$lines[$i+$j];
		if($str1[0]==":")	break;
		$str1=explode("|",$str1);	$str1=$str1[1];
		array_push($str2, $str1);
		$str1=$lines[$i+$j+1];
		$str1=explode("|",$str1);	$str1=$str1[1];
		array_push($str2, $str1);
		$str1=$lines[$i+$j+2];
		$str1=explode("|",$str1);	$str1=$str1[1];
		array_push($str2, $str1);
		array_push($cvexperiences, $str2);
		$j+=3;
	}
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[11][0]=>array("label"=>$label,"value"=>$cvexperiences));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=($j+1);
	if($i>$num)	return(true);
	$j=0;
	$cvmembership=array();
	while($j<=$num-$i)
	{
		$str2=array();
		$str1=$lines[$i+$j];
		if($str1[0]==":")	break;
		$str1=explode("|",$str1);	$str1=$str1[1];
		array_push($str2, $str1);
		$str1=$lines[$i+$j+1];
		$str1=explode("|",$str1);	$str1=$str1[1];
		array_push($str2, $str1);
		$str1=$lines[$i+$j+2];
		$str1=explode("|",$str1);	$str1=$str1[1];
		array_push($str2, $str1);
		array_push($cvmembership, $str2);
		$j+=3;
	}
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[12][0]=>array("label"=>$label,"value"=>$cvmembership));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=($j+1);
	if($i>$num)	return(true);
	$j=0;
	$cvteachingexperience=array();
	while($j<=$num-$i)
	{
		$str2=array();
		$str1=$lines[$i+$j];
		if($str1[0]==":")	break;
		$str1=explode("|",$str1);	$str1=$str1[1];
		array_push($str2, $str1);
		$str1=$lines[$i+$j+1];
		$str1=explode("|",$str1);	$str1=$str1[1];
		array_push($str2, $str1);
		$str1=$lines[$i+$j+2];
		$str1=explode("|",$str1);	$str1=$str1[1];
		array_push($str2, $str1);
		array_push($cvteachingexperience, $str2);
		$j+=3;
	}
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[13][0]=>array("label"=>$label,"value"=>$cvteachingexperience));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=($j+1);
	if($i>$num)	return(true);
	$j=0;
	$cveducation=array();
	while($j<=$num-$i)
	{
		$str2=array();
		$str1=$lines[$i+$j];
		if($str1[0]==":")	break;
		$str1=explode("|",$str1);	$str1=$str1[1];
		array_push($str2, $str1);
		$str1=$lines[$i+$j+1];
		$str1=explode("|",$str1);	$str1=$str1[1];
		array_push($str2, $str1);
		$str1=$lines[$i+$j+2];
		$str1=explode("|",$str1);	$str1=$str1[1];
		array_push($str2, $str1);
		array_push($cveducation, $str2);
		$j+=3;
	}
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[14][0]=>array("label"=>$label,"value"=>$cveducation));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=($j+1);
	if($i>$num)	return(true);
	$j=0;
	$cvaward=array();
	while($j<=$num-$i)
	{
		$str2=array();
		$str1=$lines[$i+$j];
		if($str1[0]==":")	break;
		$str1=explode("|",$str1);	$str1=$str1[1];
		array_push($str2, $str1);
		$str1=$lines[$i+$j+1];
		$str1=explode("|",$str1);	$str1=$str1[1];
		array_push($str2, $str1);
		$str1=$lines[$i+$j+2];
		$str1=explode("|",$str1);	$str1=$str1[1];
		array_push($str2, $str1);
		array_push($cvaward, $str2);
		$j+=3;
	}
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[15][0]=>array("label"=>$label,"value"=>$cvaward));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=($j+1);
	if($i>$num)	return(true);
	$j=0;
	while($j<=$num-$i)
	{
		$str1=$lines[$i+$j];
		if($str1[0]==":")	break;
		if($j==0)	
		{
			$cvresearchexperience=substr($str1,1);
		}
		else
		{
			$cvresearchexperience.=$str1;
		}
		$j++;
	}
	$cvresearchexperience=substr($cvresearchexperience,0,strrpos($cvresearchexperience,"|"));
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[16][0]=>array("label"=>$label,"value"=>$cvresearchexperience));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=($j+1);
	if($i>$num)	return(true);
	$j=0;
	while($j<=$num-$i)
	{
		$str1=$lines[$i+$j];
		if($str1[0]==":")	break;
		if($j==0)	
		{
			$cvresearchinterest=substr($str1,1);
		}
		else
		{
			$cvresearchinterest.=$str1;
		}
		$j++;
	}
	$cvresearchinterest=substr($cvresearchinterest,0,strrpos($cvresearchinterest,"|"));
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[17][0]=>array("label"=>$label,"value"=>$cvresearchinterest));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=($j+1);
	if($i>$num)	return(true);
	$str1=explode("|",$lines[$i]);	$str1=$str1[1];
	if(substr($str1,0,6)!="photo.") $cvphotolink="photo.jpg";
	else $cvphotolink=$str1;
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[18][0]=>array("label"=>$label,"value"=>$cvphotolink));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=2;
	if($i>$num)	return(true);
	$str1=explode("|",$lines[$i]);	$str1=$str1[1];
	$cvprojectslink=$str1;
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[19][0]=>array("label"=>$label,"value"=>$cvprojectslink));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=2;
	if($i>$num)	return(true);
	$str1=explode("|",$lines[$i]);	$str1=$str1[1];
	$cvpublicationslink=$str1;
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[20][0]=>array("label"=>$label,"value"=>$cvpublicationslink));
	$cvdata=array_merge($cvdata,$cvitem);

	$i+=2;
	if($i>$num)	return(true);
	$str1=explode("|",$lines[$i]);	$str1=$str1[1];
	$str2=explode("|",$lines[$i+1]);	$str2=$str2[1];
	$cvskills=array($str1,$str2);
	$label=explode(":",$lines[$i-1]);
	$cvitem=array($cvitems[21][0]=>array("label"=>$label,"value"=>$cvskills));
	$cvdata=array_merge($cvdata,$cvitem);

	return(true);
}


?>
